//
//  "$Id: Types.h 900 2009-04-18 03:37:45Z liwj $"
//
//  Copyright (c)2008-2008, ZheJiang JuFeng Technology Stock CO.LTD.
//  All Rights Reserved.
//
//	Description:	
//	Revisions:		Year-Month-Day  SVN-Author  Modification
//


#ifndef __XC_TYPES_H__
#define __XC_TYPES_H__

//////////////////////////////////////////////////////////////////////////
// base types definition
// compilers should be restricted to ensure the following equalities!
typedef signed char				schar;	///< sizeof(uchar) == sizeof(schar) == sizeof(char) == 1
typedef unsigned char			uchar;	
typedef unsigned int			uint;	///< sizeof(uint) == sizeof(int) == 4
typedef unsigned short			ushort;	///< sizeof(ushort) == sizeof(short) == 2
typedef unsigned long			ulong;	///< sizeof(ulong) == sizeof(long) == 4
#ifdef WIN32
	typedef __int64					int64;	///< sizeof(int64) == sizeof(uint64) == 8
	typedef unsigned __int64		uint64;
#elif defined(__GNUC__)
	typedef unsigned long long		int64;
	typedef long long				uint64;
#endif

#ifndef __SMALL_FILE_TIME_DEFINED__
#define __SMALL_FILE_TIME_DEFINED__
//ʱṹ
typedef struct _TIME_								
{
#ifdef __BIG_ENDIAN__
	uint year		:6;				//		2000-2063	
	uint month		:4;				//		1-12		
	uint day		:5;				//		1-31		
	uint hour		:5;				//	ʱ	0-23		
	uint minute		:6;				//		0-59		
	uint second		:6;				//		0-59	
#else
	uint second		:6;				//		0-59		
	uint minute		:6;				//		0-59		
	uint hour		:5;				//	ʱ	0-23		
	uint day		:5;				//		1-31		
	uint month		:4;				//		1-12		
	uint year		:6;				//		2000-2063	
#endif
}DateTime,*pTIME;

#endif

typedef union {	//IP addr
	uchar	c[4];
	ushort	s[2];
	uint	l;
} IPAddress;

struct TimeSection
{
	//!ʹ
	int enable;
	//!ʼʱ:Сʱ
	int startHour;
	//!ʼʱ:
	int	startMinute;
	//!ʼʱ:
	int	startSecond;
	//!ʱ:Сʱ
	int	endHour;
	//!ʱ:
	int	endMinute;
	//!ʱ:
	int	endSecond;
};

/// ϵͳʱṹ,ҪPAL/System.hеSYSTEM_TIMEһ
struct SystemTime
{
	int  year;		///< ꡣ   
	int  month;		///< £January = 1, February = 2, and so on.   
	int  day;		///< ա   
	int  wday;		///< ڣSunday = 0, Monday = 1, and so on   
	int  hour;		///< ʱ   
	int  minute;	///< ֡   
	int  second;	///< 롣   
	int  isdst;		///< ʱʶ   
} ;

typedef struct {
   int left;
   int top;
   int right;
   int bottom;
}Rect,*RectPtr;

typedef struct {
	int x;
	int y;
}Point,*PointPtr;

typedef struct {
	int w;
	int h;
}Size,*SizePtr;

#endif// _TYPES_H__

